﻿Imports System.Runtime.CompilerServices
''' <summary>
''' Extension die DataRow
''' </summary>
Public Module DataRowExtensions

    ''' <summary>
    ''' Datensatz sperren
    ''' </summary>
    ''' <param name="row">Datensatz</param>
    ''' <returns>LockInformation</returns>
    <Extension()>
    Public Function Lock(row As DataRow) As LockInfo
        Dim mLockInfo As LockInfo = LockManager.Lock(row)
        Return mLockInfo
    End Function

    ''' <summary>
    ''' Datensatz prüfen, ob Sperrung noch gültig (LockTimeout abgelaufen?)
    ''' </summary>
    ''' <param name="row">Datensatz</param>
    ''' <returns>True/False</returns>
    <Extension()>
    Public Function CheckLock(row As DataRow) As Boolean
        If Not LockManager.CompareDataRowWithLockInfo(row) Then Return False
        Return LockManager.CheckLock()
    End Function

    ''' <summary>
    ''' Datensatz prüfen, ob Sperrung noch gültig (LockTimeout abgelaufen?)
    ''' </summary>
    ''' <param name="row">Datensatz</param>
    ''' <param name="pLockInfo">Bestimmte LockInformation</param>
    ''' <returns>True/False</returns>
    <Extension()>
    Public Function CheckLock(row As DataRow, pLockInfo As LockInfo) As Boolean
        If Not LockManager.CompareDataRowWithLockInfo(row, pLockInfo) Then Return False
        Return LockManager.CheckLock(pLockInfo)
    End Function

    ''' <summary>
    ''' Datensatz wieder freigeben
    ''' </summary>
    ''' <param name="row">Datensatz</param>
    ''' <returns>True/False</returns>
    <Extension()>
    Public Function UnLock(row As DataRow) As Boolean
        If Not LockManager.CompareDataRowWithLockInfo(row) Then Return False
        Return LockManager.Unlock
    End Function

    ''' <summary>
    ''' Datensatz wieder freigeben
    ''' </summary>
    ''' <param name="row">Datensatz</param>
    ''' <param name="pLockInfo">Bestimmte LockInformation</param>
    ''' <returns>True/False</returns>
    <Extension()>
    Public Function UnLock(row As DataRow, pLockInfo As LockInfo) As Boolean
        If Not LockManager.CompareDataRowWithLockInfo(row, pLockInfo) Then Return False
        Return LockManager.Unlock(pLockInfo)
    End Function

End Module

