﻿Option Strict On

''' <summary>
''' Lock Informationen zum gesperrten Datensatz
''' </summary>
Public Class LockInfo: Implements IDisposable 
    Public Property SessionId As String 
    Public Property LockId As Integer
    Public Property TableName As String 
    Public Property RecordID as Integer 
    Public Property UserName as String 
    Public Property ComputerName As String 
    Public Property Success As Boolean
    Public Property LockTimeout As String

    Public Sub New()
        SessionId = LockManager.SessionId
        LockId = 0
        TableName = ""
        RecordId = 0
        UserName = LockManager.UserName 
        ComputerName = System.Environment.MachineName
        Success = False 
        LockTimeout = LockManager.GetServerDateTime()
    End Sub

    ''' <summary>
    ''' Dispose: Freigeben des gesperrten Datensatzes
    ''' Wird benötigt in einer Using Anweisung
    ''' </summary>
    Public Sub Dispose() Implements IDisposable.Dispose
        LockManager.Unlock(Me)
    End Sub

End Class

